export = DataSourceColumn;
declare function DataSourceColumn(name: string, type: string): void;
declare class DataSourceColumn {
    constructor(name: string, type: string);
    private propertiesToAssign_;
    showGlobalActions: boolean;
    weight: string | null;
    coalesceValue: any;
    pivot: boolean;
    pathRoot: number | null;
    private dimensionDataType_;
    private dimensionDataSize_;
    pathDepth: number | null;
    pathHeight: number | null;
    private format_;
    sort: string;
    name: string;
    distinct: boolean;
    private notifyNameChange_;
    suggestAlias(): void;
    alias: string;
    private updateLevel_;
    private level_;
    onBeforeAliasChange: (arg0: DataSourceColumn, arg1: string) => any;
    getLevel(): string;
    private format;
    getDimensionDataType(): string;
    getDimensionDataSize(): string;
    private getDepth;
    private setDepth;
    private getBackDepth;
    private setBackDepth;
    private getSource_;
    formatDimension(value: any): string;
    private updateDimensionDataType_;
    private updatePrefix_;
    private prefix_;
    private updateFieldName_;
    private fieldName_;
    fieldName: string;
    canonicalName: string;
    private updateCanonicalName_;
    private canonicalName_;
    aggregate: string;
    toString(): string;
}
declare namespace DataSourceColumn {
    const AGGREGATE_NONE: string;
    const AGGREGATE_SUM: string;
    const AGGREGATE_COUNT: string;
    const AGGREGATE_AVG: string;
    const AGGREGATE_MAX: string;
    const AGGREGATE_MIN: string;
    const SORT_NONE: string;
    const SORT_ASC: string;
    const SORT_DESC: string;
    const DIMENSION_SEP: string;
    function colNameFromField(fld: any, prefix: string): string;
    function fromField(fld: any, prefix: string): DataSourceColumn;
    function getRootFromLeafNode(leafNode: number, opt_suggestedRoot: number): number;
}
